
<template>
  <BasicLayout>
    <template #wrapper>
      <el-card class="box-card">
        <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="90px">
          <el-form-item label="用户组名称" prop="groupName"><el-input
            v-model="queryParams.groupName"
            placeholder="请输入用户组名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>

          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineApiGroup:add']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
            >新增
            </el-button>
          </el-col>
          <!-- <el-col :span="1.5">
                        <el-button
                                v-permisaction="['admin:lineApiGroup:edit']"
                                type="success"
                                icon="el-icon-edit"
                                size="mini"
                                :disabled="single"
                                @click="handleUpdate"
                        >修改
                        </el-button>
                    </el-col> -->
          <!-- <el-col :span="1.5">
                        <el-button
                                v-permisaction="['admin:lineApiGroup:remove']"
                                type="danger"
                                icon="el-icon-delete"
                                size="mini"
                                :disabled="multiple"
                                @click="handleDelete"
                        >删除
                        </el-button>
                    </el-col> -->
        </el-row>

        <el-table v-loading="loading" :data="lineApiGroupList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" /><el-table-column
            label="ID"
            align="center"
            prop="id"
            :show-overflow-tooltip="true"
          /><el-table-column
            label="用户组名称"
            align="center"
            prop="groupName"
            :show-overflow-tooltip="true"
          /><el-table-column
            label="绑定账户"
            align="center"
            prop="apiUserId"
            :show-overflow-tooltip="true"
          >
            <template #default="{row}">
              {{ [row.a_api_name,row.b_api_name].toString() }}
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <!-- <el-popconfirm
                           class="delete-popconfirm"
                           title="确认要修改吗?"
                           confirm-button-text="修改"
                           @confirm="handleUpdate(scope.row)"
                         >
                           <el-button
                             slot="reference"
                             v-permisaction="['admin:lineApiGroup:edit']"
                             size="mini"
                             type="text"
                             icon="el-icon-edit"
                           >修改
                           </el-button>
                         </el-popconfirm> -->
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要解绑吗?"
                confirm-button-text="解绑"
                @confirm="handleDelete(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:lineApiGroup:remove']"
                  size="mini"
                  type="text"
                >解绑
                </el-button>
              </el-popconfirm>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageIndex"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />

        <!-- 添加或修改对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px">
          <el-form ref="form" :model="form" :rules="rules" label-width="110px">
            <el-form-item label="交易所" prop="exchangeType">
              <el-select
                v-model="form.exchangeType"
                style="width: 100%;"
                placeholder="请选择交易所"
                clearable
                filterable
                size="small"
                @change="onChange"
              >
                <el-option
                  v-for="dict in exchangeTypes"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
                />
              </el-select>
            </el-form-item>
            <el-form-item label="用户组名称" prop="groupName">
              <el-input
                v-model="form.groupName"
                placeholder="用户组名称"
              />
            </el-form-item>
            <el-form-item label="主账号" prop="pid">
              <el-select v-model="form.pid" placeholder="请选择主账号" style="width: 100%;">
                <el-option v-for="(a,i) in accounts" :key="i" :value="a.id" :label="a.apiName" />
              </el-select>
            </el-form-item>
            <el-form-item label="副账号" prop="sid">
              <el-select v-model="form.sid" placeholder="请选择副账号" style="width: 100%;">
                <el-option v-for="(a,i) in comAccounts" :key="i" :value="a.id" :label="a.apiName" />
              </el-select>
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-card>
    </template>
  </BasicLayout>
</template>

<script>
import { delLineApiGroup, getLineApiGroup, listLineApiGroup, updateLineApiGroup, getUser, userbind } from '@/api/admin/line-api-group'
export default {
  name: 'LineApiGroup',
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      isEdit: false,
      // 类型数据字典
      typeOptions: [],
      lineApiGroupList: [],

      // 关系表类型

      // 查询参数
      queryParams: {
        pageIndex: 1,
        pageSize: 10,
        groupName: undefined
      },
      accounts: [],
      // 表单参数
      form: {
      },
      pid: undefined,
      sid: undefined,
      // 表单校验
      rules: {
        exchangeType: [{ required: true, message: '交易所不能为空', trigger: 'blur' }],
        groupName: [{ required: true, message: '用户组名称不能为空', trigger: 'blur' }],
        pid: [{ required: true, message: '主账号不能为空', trigger: 'blur' }],
        sid: [{ required: true, message: '副账号不能为空', trigger: 'blur' }]
      },
      exchangeTypes: []
    }
  },
  computed: {
    comAccounts() {
      return this.accounts.filter(a => a.id !== this.form.pid)
    }
  },
  created() {
    this.getList()
    // 获取交易所字典数据
    this.getDicts('exchange_type').then(response => {
      this.exchangeTypes = response.data
      this.apiGetUser(this.exchangeTypes.length ? this.exchangeTypes[0].value : '')
    })
  },
  methods: {
    onChange() {
      this.exchangeTypes = []
      this.apiGetUser()
    },
    // 获取用户
    apiGetUser(exchangeType) {
      getUser({ exchangeType: exchangeType || this.form.exchangeType }).then(response => {
        this.accounts = response.data
      })
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listLineApiGroup(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.lineApiGroupList = response.data.list
        this.total = response.data.count
        this.loading = false
      }
      )
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        exchangeType: this.exchangeTypes.length ? this.exchangeTypes[0].value : '',
        id: undefined,
        groupName: undefined,
        apiUserId: undefined,
        pid: undefined,
        sid: undefined
      }
      this.resetForm('form')
    },
    getImgList: function() {
      this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
    },
    fileClose: function() {
      this.fileOpen = false
    },
    // 关系
    // 文件
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageIndex = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加用户绑定从属关系表'
      this.isEdit = false
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id =
                row.id || this.ids
      getLineApiGroup(id).then(response => {
        const { data } = response || {}
        this.form = data
        this.open = true
        this.title = '修改用户绑定从属关系表'
        this.isEdit = true
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateLineApiGroup(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            const { groupName, pid, sid, exchangeType } = this.form
            userbind({ group_name: groupName, user_id_str: `${pid},${sid}`, exchangeType }).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      var Ids = (row.id && [row.id]) || this.ids

      this.$confirm('是否确认解绑编号为"' + Ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delLineApiGroup({ 'ids': Ids })
      }).then((response) => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.open = false
          this.getList()
          getUser().then(response => {
            this.accounts = response.data
          })
        } else {
          this.msgError(response.msg)
        }
      }).catch(function() {
      })
    }
  }
}
</script>
